<?php

/**
-------------------------------------------------------------------------
wallfactory - Wall Factory 4.0.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class WallFactoryHelper
{
    public static function addSubmenu($view)
    {
        $menu = array(
            'dashboard',
            'users',
            'posts',
            'comments',
            'reports',
            'bookmarks',
            'notifications',
            'configuration',
            'about',
        );

        $inflector = \Joomla\String\Inflector::getInstance();
        $inflector->addWord('feedback', 'list');
        $singular = $inflector->toSingular($view);
        $plural = $inflector->toPlural($view);

        foreach ($menu as $item) {
            JHtmlSidebar::addEntry(
                self::submenuText($item),
                self::submenuRoute($item),
                in_array($item, array($view, $singular, $plural)) ? true : false
            );
        }
    }

    public static function filterBannedWords($text)
    {
        static $words = null;

        if (null === $words) {
            $words = trim($words);

            if ('' === $words) {
                $words = false;
            }
            else {
                $configuration = JComponentHelper::getParams('com_wallfactory');
                $banned = $configuration->get('moderation.banned.words');
                $words = preg_split('/\r\n|\r|\n/', $banned);
            }
        }

        if (!$words) {
            return $text;
        }

        return str_ireplace($words, '***', $text);
    }

    private static function submenuRoute($item)
    {
        return WallFactoryRoute::view($item);
    }

    private static function submenuText($item)
    {
        if ('reports' === $item) {
            $model = JModelLegacy::getInstance('Reports', 'WallFactoryBackendModel', array('ignore_request' => true));
            $unresolved = $model->countUnresolvedReports();

            return WallFactoryText::plural('submenu_count_' . $item, number_format($unresolved, 0));
        }

        return WallFactoryText::_('submenu_' . $item);
    }
}
