<?php

/**
-------------------------------------------------------------------------
wallfactory - Wall Factory 4.0.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class WallFactoryBackendModelConfiguration extends JModelAdmin
{
    protected $option = 'com_wallfactory';

    public function getForm($data = array(), $loadData = false)
    {
        $form = WallFactoryForm::load($this->getName());

        $this->parseCommunityBuilderIntegration($form);

        return $form;
    }

    public function save($data)
    {
        $form = $this->getForm();
        $data = WallFactoryForm::validate($form, $data);

        $extension = JTable::getInstance('Extension');
        $extension->load(array(
            'element' => $this->option,
            'type' => 'component',
        ));

        $extension->bind(array(
            'params' => $data
        ));

        $extension->store();

        parent::cleanCache('_system', 1);
        parent::cleanCache('_system', 0);

        return true;
    }

    private function parseCommunityBuilderIntegration(JForm $form)
    {
        $extension = JTable::getInstance('Extension');
        $result = $extension->find(array(
            'type'    => 'component',
            'element' => 'com_comprofiler',
            'enabled' => 1,
        ));

        $name = 'community_builder_' . ($result ? 'enabled' : 'disabled');

        $form->loadFile(JPATH_ADMINISTRATOR . '/components/com_wallfactory/models/forms/configuration/' . $name . '.xml');

        WallFactoryForm::addLabelsToForm($form);
    }
}
