<?php

/**
-------------------------------------------------------------------------
wallfactory - Wall Factory 4.0.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

?>

<style>
  .panel {
    background-color: #fff;
    border: 1px solid #ddd;
    border-radius: 4px;
    box-shadow: 0 1px 1px rgba(0, 0, 0, 0.05);
    margin-bottom: 20px;
  }

  .panel-heading {
    border-bottom: 1px solid #ddd;
    border-top-left-radius: 3px;
    border-top-right-radius: 3px;
    padding: 10px 15px;
    background-color: #f5f5f5;
    color: #333;
  }

  .panel-title {
    color: inherit;
    font-size: 16px;
    margin-bottom: 0;
    margin-top: 0;
  }

  .panel-body {
    padding: 15px;
  }

  div.versions {
    width: 180px;
  }

  div.new-version {
    margin-top: 10px;
    font-weight: bold;
    background-color: #ff0000;
    color: #ffffff;
    display: inline-block;
    padding: 3px 10px;
  }

  div.latest-version {
    margin-top: 10px;
    font-weight: bold;
      background-color: #3c763d;
    color: #ffffff;
    display: inline-block;
    padding: 3px 10px;
  }

  div.fb-wrapper {
    margin-left: 50px;
  }

  div.version-history {
    margin-top: 20px;
  }
</style>

<script type="text/javascript">
  (function(d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s); js.id = id;
    js.src = "//connect.facebook.net/en_US/all.js#xfbml=1";
    fjs.parentNode.insertBefore(js, fjs);
  }(document, 'script', 'facebook - jssdk'));
</script>

<div id="j-sidebar-container" class="span2">
  <?php echo $this->sidebar; ?>
</div>

<div id="j-main-container" class="span10">
  <div class="panel">
    <div class="panel-heading">
      <h3 class="panel-title">
        <?php echo WallFactoryText::_('ABOUT_HEADING_RELEASE_NOTES'); ?>
      </h3>
    </div>

    <div class="panel-body">
      <div class="pull-left versions">
        <div>
          <?php echo WallFactoryText::_('ABOUT_CURRENT_VERSION'); ?>
          <b class="pull-right"><?php echo $this->manifest->getCurrentVersion(); ?></b>
        </div>

        <div>
          <?php echo WallFactoryText::_('ABOUT_LATEST_VERSION'); ?>
          <b class="pull-right"><?php echo $this->manifest->getLatestVersion(); ?></b>
        </div>

        <?php if ($this->manifest->isUpdateAvailable()): ?>
          <div class="new-version">
            <?php echo WallFactoryText::_('ABOUT_NEW_VERSION_AVAILABLE'); ?>
          </div>
        <?php else: ?>
          <div class="latest-version">
            <?php echo WallFactoryText::_('ABOUT_LATEST_VERSION_INSTALLED'); ?>
          </div>
        <?php endif; ?>
      </div>

      <div class="pull-left fb-wrapper">
        <div class="fb-like" data-href="https://www.facebook.com/theFactoryJoomla" data-send="false" data-layout="box_count" data-width="450" data-show-faces="false"></div>
      </div>

      <div style="clear: both;"></div>

      <div class="version-history">
        <?php echo $this->manifest->getVersionHistory(); ?>
      </div>
    </div>
  </div>

  <div class="panel">
    <div class="panel-heading">
      <h3 class="panel-title">
        <?php echo WallFactoryText::_('ABOUT_HEADING_SUPPORT_AND_UPDATES'); ?>
      </h3>
    </div>

    <div class="panel-body">
      <?php echo $this->manifest->getSupportAndUpdates(); ?>
    </div>
  </div>

  <div class="panel">
    <div class="panel-heading">
      <h3 class="panel-title">
        <?php echo WallFactoryText::_('ABOUT_HEADING_OTHER_PRODUCTS'); ?>
      </h3>
    </div>

    <div class="panel-body">
      <?php echo $this->manifest->getOtherProducts(); ?>
    </div>
  </div>

  <div class="panel">
    <div class="panel-heading">
      <h3 class="panel-title">
        <?php echo WallFactoryText::_('ABOUT_HEADING_ABOUT_COMPANY'); ?>
      </h3>
    </div>

    <div class="panel-body">
      <?php echo $this->manifest->getAboutCompany(); ?>
    </div>
  </div>
</div>

<form action="<?php echo WallFactoryRoute::view($this->getName());?>" id="adminForm" method="post" name="adminForm">
  <input type="hidden" name="task" value="" />
</form>
