<?php

/**
-------------------------------------------------------------------------
wallfactory - Wall Factory 4.0.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

/** @var WallFactoryBackendModelReports $model */
$model = JModelLegacy::getInstance('Reports', 'WallFactoryBackendModel', array(
  'ignore_request' => true,
  'state' => new JObject(array(
    'list.limit' => 5
  )),
));

$results = $model->getItems();

?>

<style>
  div.dashboard table.table span.label {
    font-size: 10px;
    line-height: normal;
    padding: 0 5px 2px;
    text-transform: lowercase;
  }
</style>

<?php if ($results): ?>
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="thinnest"></th>
      <th class="thinnest">Status</th>
      <th>Report</th>
      <th class="thinnest">Date</th>
    </tr>
    </thead>

    <tbody>
    <?php foreach ($results as $item): ?>
      <tr>
        <td>
          <a href="<?php echo WallFactoryRoute::task('report.edit&id=' . $item->id); ?>" class="btn btn-mini"><span class="fa fa-fw fa-pencil"></span></a>
        </td>

        <td>
          <?php echo JHtml::_('WallFactory.reportStatus', $item->resolved); ?>
        </td>

        <td>
<!--          <a href="--><?php //echo WallFactoryRoute::task($item->resource_type . '.edit&id=' . $item->id); ?><!--">--><?php //echo $item->resource_title; ?><!--</a>-->
<!--          <span class="small muted">-->
<!--            --><?php //echo WallFactoryText::_('report_type_' . $item->resource_type); ?>
<!--          </span>-->
<!---->
<!--          <div style="margin-top: 7px;">-->
<!--            --><?php //echo JHtml::_('string.truncate', $item->comment, 150, true, false); ?>
<!--          </div>-->

          <?php echo JHtml::_('string.truncate', $item->comment, 150, true, false); ?>
        </td>

        <td class="nowrap muted">
          <?php echo JHtml::_('date', $item->created_at, 'COM_WALLFACTORY_DASHBOARD_FORMAT_DATE'); ?>
        </td>
      </tr>
    <?php endforeach; ?>
    </tbody>
  </table>
<?php endif; ?>

<?php if (!$results): ?>
  <div class="no-results">
    <?php echo WallFactoryText::_('dashboard_panel_report_latest_no_results'); ?>
  </div>
<?php endif; ?>

<div class="actions">
  <a href="<?php echo WallFactoryRoute::view('reports&reset=1'); ?>">
    <?php echo WallFactoryText::_('dashboard_panel_report_latest_link_all_reports'); ?>
  </a>
</div>

