<?php

/**
-------------------------------------------------------------------------
wallfactory - Wall Factory 4.0.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class WallFactoryEventSubscriberSubscription extends JEvent
{
    public static function onProfileRemoved($context, $profile)
    {
        if ('com_wallfactory' !== $context || !$profile instanceof WallFactoryTableProfile) {
            return null;
        }

        $subscriptionRepo = new WallFactoryFrontendModelSubscriptions();
        $subscriptions = $subscriptionRepo->findByUser($profile->user_id);

        $message = $subscriptions
            ? sprintf('Removing profile %d subscriptions: %s', $profile->user_id, implode(', ', array_keys($subscriptions)))
            : sprintf('Profile %d has no subscriptions.', $profile->user_id);

        WallFactoryLogger::log($message, 'entity');

        foreach ($subscriptions as $subscription) {
            $subscription->delete();
        }

        return null;
    }
}
